(function() {

        if (!window.onerror) {
            window.onerror = function(msg, url, line) {
                console.log("LSJavascriptBridge: ERROR:" + msg + "@" + url + ":" + line);
            }
        }

        if (!window.navigationBarControl) {

            function _setNavigationBarTitle(title) {
                LSJavascriptBridge.callHandler("setNavigationBarTitle", title, function responseCallback(responseData) {
                })
            }

            function _setNavigationBarButton(button) {
                LSJavascriptBridge.callHandler("setNavigationBarButton", button, function responseCallback(responseData) {
                })
            }

            function _showNavigationBarMenu(menu) {
                LSJavascriptBridge.callHandler("showNavigationBarMenu", menu, function responseCallback(responseData) {
                })
            }

            window.navigationBarControl = {
                setNavigationBarTitle  : _setNavigationBarTitle,
                setNavigationBarButton : _setNavigationBarButton,
                showNavigationBarMenu  : _showNavigationBarMenu
            }
        }

        if (!window.enterpriseGroupDelegate) {
            function _onJoinEnterpriseGroupSucceed(groupInfo) {
                LSJavascriptBridge.callHandler("onJoinEnterpriseGroupSucceed", groupInfo, function responseCallback(responseData) {
                })
            }

            function _onQuiteEnterpriseGroupSucceed(groupId) {
                LSJavascriptBridge.callHandler("onQuiteEnterpriseGroupSucceed", groupId, function responseCallback(responseData) {
                })
            }

            window.enterpriseGroupDelegate = {
                onJoinEnterpriseGroupSucceed   : _onJoinEnterpriseGroupSucceed,
                onQuiteEnterpriseGroupSucceed  : _onQuiteEnterpriseGroupSucceed
            }
        }

        if (!window.lxPayDelegate) {
            function _sendWxPayRequest(wxPayReq) {
                LSJavascriptBridge.callHandler("sendWxPayRequest", wxPayReq, function responseCallback(responseData) {
                })
            }

            window.lxPayDelegate = {
                sendWxPayRequest  : _sendWxPayRequest,
            }
        }

        if (!window.generalEventDelegate) {
            function _onUnexpectedError(errorCode) {
                LSJavascriptBridge.callHandler("onUnexpectedError", errorCode, function responseCallback(responseData) {
                })
            }

            window.generalEventDelegate = {
                onUnexpectedError  : _onUnexpectedError,
            }
        }

        if (!window.local_obj) {
            function _setShareType(type) {
                LSJavascriptBridge.callHandler("setShareType", type, function responseCallback(responseData) {
                })
            }

            function _onMenuShareTimeline(shareData) {
                LSJavascriptBridge.callHandler("onMenuShareTimeline", shareData, function responseCallback(responseData) {
                })
            }

            function _onMenuShareAppMessage(shareData) {
                LSJavascriptBridge.callHandler("onMenuShareAppMessage", shareData, function responseCallback(responseData) {
                })
            }

            function _onMenuShareQQ(shareData) {
                LSJavascriptBridge.callHandler("onMenuShareQQ", shareData, function responseCallback(responseData) {
                })
            }

            function _onMenuShareWeibo(shareData) {
                LSJavascriptBridge.callHandler("onMenuShareWeibo", shareData, function responseCallback(responseData) {
                })
            }

            function _onMenuShareQZone(shareData) {
                LSJavascriptBridge.callHandler("onMenuShareQZone", shareData, function responseCallback(responseData) {
                })
            }

            function _jump(viewType, data) {
                var params = data ? data : {};
                LSJavascriptBridge.callHandler("jump", {viewType : viewType, data : params}, function responseCallback(responseData) {
                })
            }

            function _getSleepData(time) {
                var data = LSJavascriptBridge.callSyncHandler("getSleepData", time);
                return  JSON.stringify(data);
            }


            window.local_obj = {
                setShareType          : _setShareType,
                onMenuShareTimeline   : _onMenuShareTimeline,
                onMenuShareAppMessage : _onMenuShareAppMessage,
                onMenuShareQQ         : _onMenuShareQQ,
                onMenuShareWeibo      : _onMenuShareWeibo,
                onMenuShareQZone      : _onMenuShareQZone,
                jump                  : _jump,
                getSleepData          : _getSleepData,
            }
        }
    })();
